gLevelValues.exitCastleLevel = 16
gLevelValues.exitCastleArea = 1
gLevelValues.exitCastleWarpNode = 10

gLevelValues.metalCapDurationCotmc = 1
gLevelValues.wingCapDurationTotwc = 1
gLevelValues.vanishCapDurationVcutm = 1

gBehaviorValues.starsNeededForDialog.dialog1 = 12
gBehaviorValues.starsNeededForDialog.dialog2 = 45
gBehaviorValues.starsNeededForDialog.dialog3 = 75
gBehaviorValues.starsNeededForDialog.dialog4 = 110
gBehaviorValues.starsNeededForDialog.dialog5 = 111
gBehaviorValues.starsNeededForDialog.dialog6 = 132

gLevelValues.mushroom1UpHeal = 1
gLevelValues.fixVanishFloors = true
gBehaviorValues.ChillBullyDeathPosY = -1300
gLevelValues.coinsRequiredForCoinStar = 0

gBehaviorValues.trajectories.BowlingBallBobTrajectory = get_trajectory('custom0_path')
gBehaviorValues.trajectories.BowlingBallBob2Trajectory = get_trajectory('custom1_path')
gBehaviorValues.trajectories.BowlingBallTtmTrajectory = get_trajectory('custom1_path')

--Infiite Lives--

hook_event(HOOK_MARIO_UPDATE,
function(m)
	if m.playerIndex ~= 0 then return end

	if (m.numLives < 100) then
		m.numLives = 100
	end
end)

--Leave Level Stars--

---@param m MarioState
function mario_update(m)
	if m.playerIndex ~= 0 then return end
	---@type NetworkPlayer
	local np = gNetworkPlayers[0]

	if (np.currLevelNum == LEVEL_BITS and np.currAreaIndex == 2) or (np.currLevelNum == LEVEL_THI) then
		if m.action == ACT_STAR_DANCE_NO_EXIT then
			set_mario_action(m, ACT_STAR_DANCE_EXIT, 0)
		end
	end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

--Act Select--

function ActSelect()
	---@type NetworkPlayer
	local np = gNetworkPlayers[0]

	if (np.currLevelNum == LEVEL_BITS and np.currAreaIndex == 2) or
		(np.currLevelNum == LEVEL_BOWSER_3) or
		(np.currLevelNum == LEVEL_THI) then
		return false
	end
end

hook_event(HOOK_USE_ACT_SELECT, ActSelect)