----------------
-----Models-----
----------------

-- If any of these are needed in another file, like the exclamation box, just make models you need global

local E_MODEL_FLAME = smlua_model_util_get_id("flame_geo")
local E_MODEL_PLATC3 = smlua_model_util_get_id("platc3_geo")
local E_MODEL_C1TRI = smlua_model_util_get_id("c1tri_geo")
local E_MODEL_C1DROP = smlua_model_util_get_id("c1drop_geo")
local E_MODEL_C7WATER = smlua_model_util_get_id("c7water_geo")
local E_MODEL_C7WOOD = smlua_model_util_get_id("c7wood_geo")
local E_MODEL_C4MOP = smlua_model_util_get_id("c4mop_geo")
local E_MODEL_C4ROT = smlua_model_util_get_id("c4rot_geo")
local E_MODEL_C4SINK = smlua_model_util_get_id("c4sink_geo")
local E_MODEL_C4TTC = smlua_model_util_get_id("c4ttc_geo")
local E_MODEL_C5A3 = smlua_model_util_get_id("c5a3_geo")
local E_MODEL_C5A2 = smlua_model_util_get_id("c5a2_geo")
local E_MODEL_C8PLAT = smlua_model_util_get_id("c8plat_geo")
local E_MODEL_C8ROT = smlua_model_util_get_id("c8rot_geo")
local E_MODEL_C9WOOD = smlua_model_util_get_id("c9wood_geo")
local E_MODEL_C9WOOD2 = smlua_model_util_get_id("c9wood2_geo")
local E_MODEL_C9WOOD3 = smlua_model_util_get_id("c9wood3_geo")
local E_MODEL_C9BARRIER = smlua_model_util_get_id("c9barrier_geo")
local E_MODEL_C9BREAK = smlua_model_util_get_id("c9break_geo")
local E_MODEL_C9PENGUIN = smlua_model_util_get_id("c9penguin_geo")
local E_MODEL_B2ROT = smlua_model_util_get_id("b2rot_geo")
local E_MODEL_B1FPLAT = smlua_model_util_get_id("b1fplat_geo")
local E_MODEL_B2FPLAT = smlua_model_util_get_id("b2fplat_geo")
local E_MODEL_B3ROT = smlua_model_util_get_id("b3rot_geo")
local E_MODEL_B3ROT2 = smlua_model_util_get_id("b3rot2_geo")
local E_MODEL_B3ROT3 = smlua_model_util_get_id("b3rot3_geo")
local E_MODEL_C10BOX = smlua_model_util_get_id("c10box_geo")
local E_MODEL_C12PLAT = smlua_model_util_get_id("c12plat_geo")
local E_MODEL_C12PLAT2 = smlua_model_util_get_id("c12plat2_geo")
local E_MODEL_WCLIGHT = smlua_model_util_get_id("wclight_geo")
local E_MODEL_WCPLATP = smlua_model_util_get_id("wcplatp_geo")
local E_MODEL_WCPLATG = smlua_model_util_get_id("wcplatg_geo")
local E_MODEL_VCPLAT = smlua_model_util_get_id("vcplat_geo")
local E_MODEL_VCPLAT2 = smlua_model_util_get_id("vcplat2_geo")
local E_MODEL_VCPLAT3 = smlua_model_util_get_id("vcplat3_geo")
local E_MODEL_OWGATE = smlua_model_util_get_id("owgate_geo")
local E_MODEL_S1BLOCK = smlua_model_util_get_id("s1block_geo")
local E_MODEL_S1BLOCK2 = smlua_model_util_get_id("s1block2_geo")
local E_MODEL_MCPLAT = smlua_model_util_get_id("mcplat_geo")

--------------------
-----Collisions-----
--------------------

local COL_PLATC3 = smlua_collision_util_get("platc3_collision")
local COL_PIPE = smlua_collision_util_get("warp_pipe_seg3_collision_03009AC8")
local COL_C1TRI = smlua_collision_util_get("c1tri_collision")
local COL_C1DROP = smlua_collision_util_get("c1drop_collision")
local COL_C7WOOD = smlua_collision_util_get("c7wood_collision")
local COL_C4MOP = smlua_collision_util_get("c4mop_collision")
local COL_C4ROT = smlua_collision_util_get("c4rot_collision")
local COL_C4SINK = smlua_collision_util_get("c4sink_collision")
local COL_C4TTC = smlua_collision_util_get("c4ttc_collision")
local COL_C5A3 = smlua_collision_util_get("c5a3_collision")
local COL_C5A2 = smlua_collision_util_get("c5a2_collision")
local COL_C8PLAT = smlua_collision_util_get("c8plat_collision")
local COL_C8ROT = smlua_collision_util_get("c8rot_collision")
local COL_C9WOOD = smlua_collision_util_get("c9wood_collision")
local COL_C9WOOD2 = smlua_collision_util_get("c9wood2_collision")
local COL_C9WOOD3 = smlua_collision_util_get("c9wood3_collision")
local COL_C9BARRIER = smlua_collision_util_get("c9barrier_collision")
local COL_C9BREAK = smlua_collision_util_get("c9break_collision")
local COL_B2ROT = smlua_collision_util_get("b2rot_collision")
local COL_B1FPLAT = smlua_collision_util_get("b1fplat_collision")
local COL_B2FPLAT = smlua_collision_util_get("b2fplat_collision")
local COL_B3ROT = smlua_collision_util_get("b3rot_collision")
local COL_B3ROT2 = smlua_collision_util_get("b3rot2_collision")
local COL_B3ROT3 = smlua_collision_util_get("b3rot3_collision")
local COL_C10BOX = smlua_collision_util_get("c10box_collision")
local COL_C12PLAT = smlua_collision_util_get("c12plat_collision")
local COL_C12PLAT2 = smlua_collision_util_get("c12plat2_collision")
local COL_WCPLATP = smlua_collision_util_get("wcplatp_collision")
local COL_VCPLAT = smlua_collision_util_get("vcplat_collision")
local COL_VCPLAT2 = smlua_collision_util_get("vcplat2_collision")
local COL_VCPLAT3 = smlua_collision_util_get("vcplat3_collision")
local COL_OWGATE = smlua_collision_util_get("owgate_collision")
local COL_S1BLOCK = smlua_collision_util_get("s1block_collision")
local COL_S1BLOCK2 = smlua_collision_util_get("s1block2_collision")
local COL_MCPLAT = smlua_collision_util_get("mcplat_collision")

-----------------------------
-----Localized Functions-----
-----------------------------

local spawn_non_sync_object = spawn_non_sync_object
local obj_set_model_extended = obj_set_model_extended
local network_init_object = network_init_object
local network_send_object = network_send_object
local load_object_collision_model = load_object_collision_model
local cur_obj_is_mario_on_platform = cur_obj_is_mario_on_platform
local cur_obj_is_any_player_on_platform = cur_obj_is_any_player_on_platform
local cur_obj_play_sound_1 = cur_obj_play_sound_1
local sins = sins
local cur_obj_become_tangible = cur_obj_become_tangible

-------------------
------Helpers------
-------------------

---@param parent Object
---@param model ModelExtendedId
---@param behaviorId BehaviorId
local function spawn_object(parent, model, behaviorId)
	local obj = spawn_non_sync_object(behaviorId, model, 0, 0, 0, nil)
	if not obj then return nil end

	obj_copy_pos_and_angle(obj, parent)
	return obj
end

---@param goal integer
---@param src integer
---@param inc integer
local function approach_by_increment(goal, src, inc)
	local diff = goal - src
	if diff > inc then
		return src + inc
	elseif diff < -inc then
		return src - inc
	else
		return goal
	end
end

---@param m MarioState
---@return boolean
local function is_bubbled(m)
	return m.action == ACT_BUBBLED
end

---@return boolean
local function is_current_area_sync_valid()
	local np = gNetworkPlayers
	for i = 1, MAX_PLAYERS - 1, 1 do
		if np[i] and np[i].connected and
		(not np[i].currLevelSyncValid or not np[i].currAreaSyncValid) and
		is_player_in_local_area(gMarioStates[i]) ~= 0 then
			return false
		end
	end
	return true
end

local function nfm(m)
	m.peakHeight = m.pos.y
   end
hook_event(HOOK_MARIO_UPDATE, nfm)

function find_y_offset_for_sinking_platform(o, sinkOffset, a23)

	if not (cur_obj_is_any_player_on_platform() == 0) then
		if o.oSinkWhenSteppedOnUnk104 < 0x4000 then
		o.oSinkWhenSteppedOnUnk104 = o.oSinkWhenSteppedOnUnk104 - sinkOffset
	else
		o.oSinkWhenSteppedOnUnk104 = 0x4000
	end
else
	if o.oSinkWhenSteppedOnUnk104 > 0 then
		o.oSinkWhenSteppedOnUnk104 = o.oSinkWhenSteppedOnUnk104 + sinkOffset
	else
		o.oSinkWhenSteppedOnUnk104 = 0
		end
	end

	local yOffset = sins(o.oSinkWhenSteppedOnUnk104) * a23
	return yOffset
	end

function sinking_perform_sink_check(o)
	local yOffset = find_y_offset_for_sinking_platform(o, -130, -1000)
	o.oGraphYOffset = 0
	o.oPosY = o.oHomeY - yOffset
end

function sinking_perform_unsink_check(o)
	local yOffset = find_y_offset_for_sinking_platform(o, 90, -4000)
	o.oGraphYOffset = 0
	o.oPosY = o.oHomeY - yOffset
end

function get_star_count()
	return save_file_get_total_star_count
	(get_current_save_file_num() - 1, COURSE_NONE, COURSE_SA)
end


--- @param obj Object
--- @param hitbox ObjectHitbox
function obj_set_hitbox(obj, hitbox)
	if not obj or not hitbox then return end
	-- Sets other hitbox values once
	if (obj.oFlags & OBJ_FLAG_30) == 0 then
		obj.oFlags = obj.oFlags | OBJ_FLAG_30

		obj.oInteractType = hitbox.interactType
		obj.oDamageOrCoinValue = hitbox.damageOrCoinValue
		obj.oHealth = hitbox.health
		obj.oNumLootCoins = hitbox.numLootCoins

		cur_obj_become_tangible()
	end

	-- Set actual hitboxes
	obj.hitboxRadius = obj.header.gfx.scale.x * hitbox.radius
	obj.hitboxHeight = obj.header.gfx.scale.y * hitbox.height
	obj.hurtboxRadius = obj.header.gfx.scale.x * hitbox.hurtboxRadius
	obj.hurtboxHeight = obj.header.gfx.scale.y * hitbox.hurtboxHeight
	obj.hitboxDownOffset = obj.header.gfx.scale.y * hitbox.downOffset
end

-------------------
-----Functions-----
-------------------

------ C3 FLame ------

local sFlame = {
	interactType	  = INTERACT_FLAME,
	downOffset		= 100,
	damageOrCoinValue = 0,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 120,
	height			= 200,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

---@param o Object
function flame_init(o)
	obj_set_model_extended(o, E_MODEL_FLAME)
	obj_set_hitbox(o, sFlame)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	cur_obj_set_home_once()
	network_init_object(o, false, { "oVelY", "oGravity", "oTimer", "oPosY", "oPosX", "oPosZ" })
end

---@param o Object
function flame_loop(o)

	if o.oTimer <= 12 then
		cur_obj_enable_rendering()
		o.oGravity = 15
		o.oVelY = 165
		cur_obj_move_using_vel_and_gravity()
		spawn_non_sync_object(id_bhvKoopaShellFlame, E_MODEL_RED_FLAME, o.oPosX, o.oPosY, o.oPosZ, nil)
	elseif o.oTimer >= 12 and o.oTimer <= 44 then
		o.oGravity = -15
		cur_obj_move_using_vel_and_gravity()
		spawn_non_sync_object(id_bhvKoopaShellFlame, E_MODEL_RED_FLAME, o.oPosX, o.oPosY, o.oPosZ, nil)
	elseif o.oTimer >= 44 and o.oTimer <= 70 then
		cur_obj_disable_rendering()
	elseif o.oTimer >= 70 then
		cur_obj_set_pos_to_home()
		o.oTimer = 0
		network_send_object(o, true)
	end
	if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
		o.oInteractStatus = 1
	end
end

bhvTumblingBridgePlatform = hook_behavior(id_bhvTumblingBridgePlatform, OBJ_LIST_GENACTOR, true, flame_init, flame_loop, "bhvTumblingBridgePlatform")

------ C3 PLAT ------

---@param o Object
function platc3_init(o)
	obj_set_model_extended(o, E_MODEL_PLATC3)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.collisionData = COL_PLATC3
	o.oCollisionDistance = 1500
	o.oHomeY = o.oPosY
	network_init_object(o, true, { 'oSinkWhenSteppedOnUnk104', 'oGraphYOffset', 'oHomeY' })
end

---@param o Object
function platc3_loop(o)

	load_object_collision_model()
		sinking_perform_sink_check(o)
	if o.oBehParams2ndByte == 1 then
		sinking_perform_unsink_check(o)
	end
end

bhvTowerDoor = hook_behavior(id_bhvTowerDoor, OBJ_LIST_SURFACE, true, platc3_init, platc3_loop, "bhvTowerDoor")

------ CUSTOMPIPE ------

---@param o Object
function bhv_waterlvl_init(o)
	obj_set_model_extended(o, E_MODEL_BITS_WARP_PIPE)
	o.oFlags = OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.collisionData = COL_PIPE
	o.oCollisionDistance = 10000
	o.header.gfx.skipInViewCheck = true
	o.oInteractType = INTERACT_WARP
	o.oIntangibleTimer = 0
	o.hitboxHeight = 50
	o.hitboxRadius = 70
end

function bhv_waterlvl_update(o)

	load_object_collision_model()
	bhv_warp_loop()
		if get_star_count() < o.oBehParams >> 24 & 0xFF then
		obj_mark_for_deletion(o)
	end
  end

id_bhvWaterLevelPillar = hook_behavior(id_bhvWaterLevelPillar, OBJ_LIST_SURFACE, true, bhv_waterlvl_init, bhv_waterlvl_update, "bhvWaterLevelPillar")

------ C1 TRI ------

---@param o Object
function flame_init(o)
	obj_set_model_extended(o, E_MODEL_C1TRI)
	o.collisionData = COL_C1TRI
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oHomeY = o.oPosY
	cur_obj_set_home_once()
	network_init_object(o, false, { "oTimer", "oPosY" })
end

---@param o Object
function flame_loop(o)

	load_object_collision_model()

	if o.oTimer <= 52 then
		o.oPosY = o.oPosY -2
	elseif o.oTimer >= 52 and o.oTimer <= 104 then
		o.oPosY = o.oPosY +2
	elseif o.oTimer >= 104 then
		o.oTimer = 0
		network_send_object(o, true)
	end
end

bhvThiHugeIslandTop = hook_behavior(id_bhvThiHugeIslandTop, OBJ_LIST_SURFACE, true, flame_init, flame_loop, "bhvThiHugeIslandTop")

------ C1 DROP ------

---@param o Object
function c1drop_init(o)
	obj_set_model_extended(o, E_MODEL_C1DROP)
	o.collisionData = COL_C1DROP
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

function c1drop_loop()

	load_object_collision_model()
	bhv_tumbling_bridge_platform_loop()
end

bhvStarDoor = hook_behavior(id_bhvStarDoor, OBJ_LIST_SURFACE, true, c1drop_init, c1drop_loop, "bhvStarDoor")

------ C7 WATER ------

local sC7Water = {
	interactType	  = INTERACT_TORNADO,
	downOffset		= 0,
	damageOrCoinValue = 0,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 527,
	height			= 1878,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

---@param o Object
function c7water_init(o)
	obj_set_model_extended(o, E_MODEL_C7WATER)
	obj_set_hitbox(o,sC7Water)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	network_init_object(o, false, { "oTimer", "oFaceAngleYaw", "oInteractStatus" })
end

---@param o Object
function c7water_loop(o)
	local m = gMarioStates[0]
	if o.oTimer <= 102 then
		o.header.gfx.scale.y = approach_f32_symmetric(o.header.gfx.scale.y, 0.4, 0.005)
	elseif o.oTimer >= 102 and o.oTimer <= 204 then
		o.header.gfx.scale.y = approach_f32_symmetric(o.header.gfx.scale.y, 1, 0.005)
	elseif o.oTimer >= 204 then
		o.oTimer = 0
		network_send_object(o, true)
	end
	o.oFaceAngleYaw = o.oFaceAngleYaw +0x800
	if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
		o.oInteractStatus = 1
	elseif obj_check_hitbox_overlap(o, m.marioObj) then
	m.vel.y = m.vel.y + 2
	end
		if obj_check_hitbox_overlap(o, m.marioObj)
		and (m.controller.buttonDown & Z_TRIG ~= 0) then
			m.vel.y = -25
		end
	end

bhvTtmRollingLog = hook_behavior(id_bhvTtmRollingLog, OBJ_LIST_GENACTOR, true, c7water_init, c7water_loop, "bhvTtmRollingLog")

------ C7 WOOD ------

---@param o Object
function c7wood_init(o)
	obj_set_model_extended(o, E_MODEL_C7WOOD)
	o.collisionData = COL_C7WOOD
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

function c7wood_loop()

	load_object_collision_model()
	bhv_bitfs_sinking_platform_loop()
end

Bhv_Custom_0x13003f98 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c7wood_init, c7wood_loop, "Bhv_Custom_0x13003f98")

------ 110 STAR ------

---@param o Object
function star110_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	bhv_init_room()
	bhv_collect_star_init()
end

---@param o Object
function star110_loop(o)
	bhv_collect_star_loop()
	if get_star_count() < 110 then
		obj_mark_for_deletion(o)
	end
end

bhvHiddenAt120Stars = hook_behavior(id_bhvHiddenAt120Stars, OBJ_LIST_LEVEL, true, star110_init, star110_loop, "bhvHiddenAt120Stars")

------ Shrink platform ------ EXTRACTED FROM MOPS

local SHRINK_TIME = 100

local SHRINK_PLATFORM_ACT_IDLE = 0
local SHRINK_PLATFORM_ACT_SHRINKING = 1
local SHRINK_PLATFORM_ACT_DISAPPEARED = 2

---@param o Object
function bhv_shrinkplatform_init(o)
	obj_set_model_extended(o, E_MODEL_C4MOP)
	o.collisionData = COL_C4MOP
end

---@param o Object
function bhv_shrinkplatform_loop(o)
	if o.oAction < SHRINK_PLATFORM_ACT_DISAPPEARED then
		load_object_collision_model()
	end

	local action = o.oAction
	if action == SHRINK_PLATFORM_ACT_SHRINKING then
		if o.oTimer == SHRINK_TIME then
			o.oAction = SHRINK_PLATFORM_ACT_DISAPPEARED
		end

		o.header.gfx.scale.x = (SHRINK_TIME - o.oTimer) / SHRINK_TIME
		o.header.gfx.scale.z = (SHRINK_TIME - o.oTimer) / SHRINK_TIME
	end

	if cur_obj_is_any_player_on_platform() == 1 and o.oAction == SHRINK_PLATFORM_ACT_IDLE and not is_bubbled(gMarioStates[0]) then
		o.oAction = SHRINK_PLATFORM_ACT_SHRINKING
	end
end

Bhv_Custom_0x130028ec = hook_behavior(nil, OBJ_LIST_SURFACE, true, bhv_shrinkplatform_init, bhv_shrinkplatform_loop, "Bhv_Custom_0x130028ec")

------ C4 ROT ------

---@param o Object
function c4rot_init(o)
	obj_set_model_extended(o, E_MODEL_C4ROT)
	o.collisionData = COL_C4ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function c4rot_loop(o)

	load_object_collision_model()

	if o.oAction == 1 then
		o.oFaceAnglePitch = o.oFaceAnglePitch + 0x80
	end

	if cur_obj_is_any_player_on_platform() == 1
	and o.oAction == 0
	and not is_bubbled(gMarioStates[0]) then
		o.oAction = 1
	end
end

Bhv_Custom_0x130028c0 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c4rot_init, c4rot_loop, "Bhv_Custom_0x130028c0")

------ C4 SINK ------

---@param o Object
function c4sink_init(o)
	obj_set_model_extended(o, E_MODEL_C4SINK)
	o.collisionData = COL_C4SINK
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oHomeY = o.oPosY
end

function c4sink_loop()

	load_object_collision_model()
	bhv_lll_sinking_rock_block_loop()
	bhv_lll_sinking_rock_block_loop()
end

Bhv_Custom_0x13002894 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c4sink_init, c4sink_loop, "Bhv_Custom_0x13002894")

------ C4 TTC ------

---@param o Object
function c4ttc_init(o)
	obj_set_model_extended(o, E_MODEL_C4TTC)
	o.collisionData = COL_C4TTC
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oHomeY = o.oPosY
end

---@param o Object
function c4ttc_loop(o)

	load_object_collision_model()
	bhv_wf_rotating_wooden_platform_loop()
	local parent = obj_get_first_with_behavior_id(id_bhvHiddenStaircaseStep)
	if parent then
		o.parentObj = parent
	else
		return
	end

	if parent.oAction == 1 then
		cur_obj_play_sound_1(SOUND_ENV_ELEVATOR2)
	end
end

bhvHiddenStaircaseStep = hook_behavior(id_bhvHiddenStaircaseStep, OBJ_LIST_SURFACE, true, c4ttc_init, c4ttc_loop, "bhvHiddenStaircaseStep")

------ C5A3 ------

---@param o Object
function c5a3_init(o)
	obj_set_model_extended(o, E_MODEL_C5A3)
	o.collisionData = COL_C5A3
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.oCollisionDistance = 5000
	o.header.gfx.skipInViewCheck = true
	network_init_object(o, false, { "oPosY" })
end

---@param o Object
function c5a3_loop(o)

	load_object_collision_model()
	if o.oTimer <= 1215 then
	o.oPosY = o.oPosY +7
	elseif o.oTimer >= 1215 then
		o.oPosY = o.oPosY +0
	end
	local np = gNetworkPlayers[0]
	local m = gMarioStates[0]
	if (np.currLevelNum == LEVEL_BBH and np.currAreaIndex == 3) then
		if is_bubbled(m) then
			warp_to_warpnode(16, 1, 0, 35)
		end
	end
end

editor_Scroll_Texture2 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c5a3_init, c5a3_loop, "editor_Scroll_Texture2")

------ C5A2 ------

---@param o Object
function c5a2_init(o)
	obj_set_model_extended(o, E_MODEL_C5A2)
	o.collisionData = COL_C5A2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.oCollisionDistance = 5000
	o.header.gfx.skipInViewCheck = true
	network_init_object(o, false, { "oTimer", "oPosY" })
end

---@param o Object
function c5a2_loop(o)

	load_object_collision_model()

	if o.oTimer <= 158 then
	 o.oPosY = o.oPosY +15
	elseif o.oTimer >= 158 and o.oTimer <= 316 then
	o.oPosY = o.oPosY -15
	elseif o.oTimer >= 316 then
		o.oTimer = 0
		network_send_object(o, true)
	end
end

bhvClockMinuteHand = hook_behavior(id_bhvClockMinuteHand, OBJ_LIST_SURFACE, true, c5a2_init, c5a2_loop, "bhvClockMinuteHand")

------ C8 PLAT ------

---@param o Object
function c8plat_init(o)
	obj_set_model_extended(o, E_MODEL_C8PLAT)
	o.collisionData = COL_C8PLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

function c8plat_loop()
	load_object_collision_model()
end

local function actionjump()

	local m = gMarioStates[0]
	if m.floor.object == nil then return end
		if obj_has_behavior_id(m.floor.object, id_bhvControllablePlatform) ~= 0 and
			(m.pos.y == m.floorHeight) or obj_has_behavior_id(m.floor.object, id_bhvPyramidElevator) ~= 0 and
			(m.pos.y == m.floorHeight) or obj_has_behavior_id(m.floor.object, id_bhvPenguinRaceFinishLine) ~= 0 and
			(m.pos.y == m.floorHeight) then

	if m.action == ACT_JUMP or
		m.action == ACT_DOUBLE_JUMP or
			m.action == ACT_TRIPLE_JUMP or
				m.action == ACT_SPECIAL_TRIPLE_JUMP or
					m.action == ACT_STEEP_JUMP or
					m.action == ACT_SIDE_FLIP or
				m.action == ACT_BACKFLIP or
			m.action == ACT_LONG_JUMP or
		m.action == ACT_RIDING_SHELL_JUMP then

		if m.floor.object.oBehParams2ndByte == 0 then
			m.pos.y = m.pos.y +5
			m.vel.y = m.vel.y +10
		elseif m.floor.object.oBehParams2ndByte == 1 then
			m.pos.y = m.pos.y +5
			m.vel.y = m.vel.y +25
		elseif m.floor.object.oBehParams2ndByte == 3 then
			m.pos.y = m.pos.y +5
			m.vel.y = m.vel.y +20
				end
			end
		end
	end

hook_event(HOOK_BEFORE_PHYS_STEP, actionjump)

bhvControllablePlatform = hook_behavior(id_bhvControllablePlatform, OBJ_LIST_SURFACE, true, c8plat_init, c8plat_loop, "bhvControllablePlatform")

------ C8ROT ------

---@param o Object
function c8rot_init(o)
	obj_set_model_extended(o, E_MODEL_C8ROT)
	o.collisionData = COL_C8ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
	network_init_object(o, true, { "oFaceAngleYaw", "oAngleVelYaw" })
end

---@param o Object
function c8rot_loop(o)

	load_object_collision_model()
	o.oFaceAngleYaw = o.oFaceAngleYaw +176
	o.oAngleVelYaw = 176
end

bhvSlidingSnowMound = hook_behavior(id_bhvSlidingSnowMound, OBJ_LIST_SURFACE, true, c8rot_init, c8rot_loop, "bhvSlidingSnowMound")

------ C9 WOOD ------

---@param o Object
function c9wood_init(o)
	obj_set_model_extended(o, E_MODEL_C9WOOD)
	o.collisionData = COL_C9WOOD
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
	network_init_object(o, true, { "oFaceAnglePitch", "oAngleVelPitch" })
end

---@param o Object
function c9wood_loop(o)

	load_object_collision_model()
	o.oFaceAnglePitch = o.oFaceAnglePitch +176
	o.oAngleVelPitch = 176
end

bhvEyerokBoss = hook_behavior(id_bhvEyerokBoss, OBJ_LIST_SURFACE, true, c9wood_init, c9wood_loop, "bhvEyerokBoss")

------ C9 WOOD2 ------

---@param o Object
function c9wood2_init(o)
	obj_set_model_extended(o, E_MODEL_C9WOOD2)
	o.collisionData = COL_C9WOOD2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
	network_init_object(o, true, { "oFaceAngleRoll", "oAngleVelRoll" })
end

---@param o Object
function c9wood2_loop(o)

	load_object_collision_model()
	o.oFaceAngleRoll = o.oFaceAngleRoll +160
	o.oAngleVelRoll = 160
end

Bhv_Custom_0x13004e5c = hook_behavior(nil, OBJ_LIST_SURFACE, true, c9wood2_init, c9wood2_loop, "Bhv_Custom_0x13004e5c")

------ C9 WOOD3 ------

---@param o Object
function c9wood3_init(o)
	obj_set_model_extended(o, E_MODEL_C9WOOD3)
	o.collisionData = COL_C9WOOD3
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
end

function c9wood3_loop()
	load_object_collision_model()
end

Bhv_Custom_0x130052e4 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c9wood3_init, c9wood3_loop, "Bhv_Custom_0x130052e4")

------ C9 BARRIER ------

---@param o Object
function c9barrier_init(o)
	obj_set_model_extended(o, E_MODEL_C9BARRIER)
	o.collisionData = COL_C9BARRIER
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
end

function c9barrier_loop()
	load_object_collision_model()
end

Bhv_Custom_0x13000ea0 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c9barrier_init, c9barrier_loop, "Bhv_Custom_0x13000ea0")

------ C9 BREAK ------

---@param o Object
function c9break_init(o)
	obj_set_model_extended(o, E_MODEL_C9BREAK)
	o.collisionData = COL_C9BREAK
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2500
end

function c9break_loop()
	load_object_collision_model()
end

bhvBreak = hook_behavior(nil, OBJ_LIST_SURFACE, true, c9break_init, c9break_loop, "bhvBreak")

------ C9 PENGUIN ------ owokitty green demon

function intersects_player(m, pos, radius)
	local mPos1 = { x = m.pos.x, y = m.pos.y + 50,  z = m.pos.z }
	local mPos2 = { x = m.pos.x, y = m.pos.y + 150, z = m.pos.z }
	return (vec3f_dist(pos, mPos1) < radius or vec3f_dist(pos, mPos2) < radius)
end

function is_invuln_or_intang(m)
	local invuln = ((m.action & ACT_FLAG_INVULNERABLE) ~= 0) or (m.invincTimer ~= 0)
	local intang = ((m.action & ACT_FLAG_INTANGIBLE) ~= 0)
	return invuln or intang
end

function object_step_nocollide(o)
	o.oPosX = o.oPosX + o.oForwardVel * sins(o.oMoveAngleYaw)
	o.oPosZ = o.oPosZ + o.oForwardVel * coss(o.oMoveAngleYaw)
	o.oPosY = o.oPosY + o.oVelY
end

function chase_local_player(o)
	m = gMarioStates[0].marioObj
	sp34 = m.header.gfx.pos.x - o.oPosX
	sp30 = m.header.gfx.pos.y + 0 - o.oPosY
	sp2C = m.header.gfx.pos.z - o.oPosZ
	sp2A = atan2s(math.sqrt(sp34 ^ 1 + sp2C ^ 2), sp30)

	obj_turn_toward_object(o, m, 16, 0x1000)
	o.oMoveAnglePitch = approach_s16_symmetric(o.oMoveAnglePitch, sp2A, 0x1000)
	o.oVelY = sins(o.oMoveAnglePitch) * 25
	o.oForwardVel = coss(o.oMoveAnglePitch) * 25
	o.oFaceAngleYaw = obj_turn_toward_object(o, m, 16, 0x1000)

	object_step_nocollide(o)
end

function bhv_demon_init(o)
	obj_set_model_extended(o, E_MODEL_C9PENGUIN)
	o.oFlags = OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.oIntangibleTimer = 0
	o.oMoveAnglePitch = -0x4000
	o.oVelY = 40
	o.header.gfx.scale.y = 0
	o.header.gfx.scale.x = 0
	o.header.gfx.scale.z = 0
	play_sound(SOUND_OBJ_BIG_PENGUIN_YELL, gMarioStates[0].marioObj.header.gfx.cameraToObject)
end

function bhv_demon_loop(o)
	local a   = { x = o.oPosX, y = o.oPosY, z = o.oPosZ }
	local m = gMarioStates[0]

	if o.oTimer >= 15 then
		o.header.gfx.scale.y = approach_f32_symmetric(o.header.gfx.scale.y, 1, 0.020)
		o.header.gfx.scale.x = approach_f32_symmetric(o.header.gfx.scale.x, 1, 0.020)
		o.header.gfx.scale.z = approach_f32_symmetric(o.header.gfx.scale.z, 1, 0.020)
		chase_local_player(o)
	end

	if not is_invuln_or_intang(m) and
	   intersects_player(m, a, 300) then
		m.health = 0xff
		return
	end

	if o.oTimer == 200 then
		play_sound(SOUND_OBJ_BIG_PENGUIN_YELL, gMarioStates[0].marioObj.header.gfx.cameraToObject)
	elseif o.oTimer >= 200 then
		o.oTimer = 15
	end

local np = gNetworkPlayers[0]
	if (np.currLevelNum == LEVEL_DDD and np.currActNum == 5) then
		if m.health == 0xff then
			warp_to_warpnode(16, 1, 0, 114)
		end
	end
end

hook_behavior(id_bhvUnagi, OBJ_LIST_DEFAULT, true, bhv_demon_init, bhv_demon_loop)

------ B2 ROT ------

---@param o Object
function b2rot_init(o)
	obj_set_model_extended(o, E_MODEL_B2ROT)
	o.collisionData = COL_B2ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function b2frot_init(o)
	obj_set_model_extended(o, E_MODEL_B2FPLAT)
	o.collisionData = COL_B2FPLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function b2rot_loop(o)

	load_object_collision_model()
	if cur_obj_is_any_player_on_platform() == 1 then
		o.oFaceAngleYaw = o.oFaceAngleYaw + 1500
		o.oAngleVelYaw = approach_by_increment(9999, o.oAngleVelYaw, 20)
	elseif cur_obj_is_any_player_on_platform() == 0 then
		o.oAngleVelYaw = 0
	end
end

bhvUkiki = hook_behavior(id_bhvUkiki, OBJ_LIST_SURFACE, true, b2rot_init, b2rot_loop, "bhvUkiki")
bhvEndToad = hook_behavior(id_bhvEndToad, OBJ_LIST_SURFACE, true, b2frot_init, b2rot_loop, "bhvEndToad")

------ KEY ------

sKey = {
	interactType	  = INTERACT_STAR_OR_KEY,
	downOffset		= 180,
	damageOrCoinValue = 0,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 50,
	height			= 175,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

---@param o Object
function key_init(o)
	obj_set_model_extended(o, E_MODEL_BOWSER_KEY)
	obj_set_hitbox(o, sKey)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
end

---@param o Object
function key_loop(o)

	bhv_collect_star_loop()
	obj_set_gfx_scale(o, 0.6, 0.6, 0.6)
end

bhvEndBirds1 = hook_behavior(id_bhvEndBirds1, OBJ_LIST_LEVEL, true, key_init, key_loop, "bhvEndBirds1")

------ KEY2 ------

sKey2 = {
	interactType	  = INTERACT_COIN,
	downOffset		= 250,
	damageOrCoinValue = 0,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 100,
	height			= 225,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

sStar = {
	interactType	  = INTERACT_COIN,
	downOffset		= 0,
	damageOrCoinValue = 0,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 80,
	height			= 50,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

---@param o Object
function key2_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	if gNetworkPlayers[0].currLevelNum == LEVEL_BOWSER_1 then
		obj_set_hitbox(o, sKey2)
	else
		obj_set_hitbox(o, sStar)
	end
end

---@param o Object
function key2_loop(o)

	local m = gMarioStates[0]

	o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800
	obj_set_gfx_scale(o, 0.9, 0.9, 0.9)
	if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
		o.oInteractStatus = 1
	elseif obj_check_hitbox_overlap(o, m.marioObj) then
		hurt_and_set_mario_action(m, ACT_HARD_BACKWARD_AIR_KB, 0, 0xFF)
	end
end

bhvSwingPlatform = hook_behavior(id_bhvSwingPlatform, OBJ_LIST_LEVEL, true, key2_init, key2_loop, "bhvSwingPlatform")

------ B1F PLAT ------

---@param o Object
function b1fplat_init(o)
	obj_set_model_extended(o, E_MODEL_B1FPLAT)
	o.collisionData = COL_B1FPLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function b1fplat_loop(o)

	load_object_collision_model()
		o.oFaceAngleYaw = o.oFaceAngleYaw + 160
		o.oAngleVelYaw = 160
	end

bhvCastleFloorTrap = hook_behavior(id_bhvCastleFloorTrap, OBJ_LIST_SURFACE, true, b1fplat_init, b1fplat_loop, "bhvCastleFloorTrap")

------ B3 ROT ------

---@param o Object
function b3rot_init(o)
	obj_set_model_extended(o, E_MODEL_B3ROT)
	o.collisionData = COL_B3ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

function b3rot_loop()
	load_object_collision_model()
end

---@param o Object
function b3updown_init(o)
	obj_set_model_extended(o, E_MODEL_B3ROT)
	o.collisionData = COL_B3ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function b3updown_loop(o)

load_object_collision_model()

if o.oTimer <= 110 then
	o.oPosY = o.oPosY -6
   elseif o.oTimer >= 110 and o.oTimer <= 220 then
   o.oPosY = o.oPosY +6
   elseif o.oTimer >= 220 then
	   o.oTimer = 0
   end
end

Bhv_Custom_0x13000230 = hook_behavior(nil, OBJ_LIST_SURFACE, true, b3rot_init, b3rot_loop, "Bhv_Custom_0x13000230")
Bhv_Custom_0x13000204 = hook_behavior(nil, OBJ_LIST_SURFACE, true, b3updown_init, b3updown_loop, "Bhv_Custom_0x13000204")

------ B3 ROT ------

---@param o Object
function b3rot_init(o)
	obj_set_model_extended(o, E_MODEL_B3ROT)
	o.collisionData = COL_B3ROT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	network_init_object(o, false, { "oTimer", "oPosY" })
end

function b3rot_loop()
	load_object_collision_model()
end

---@param o Object
function b3updown_loop(o)

	load_object_collision_model()

if o.oTimer <= 110 then
	o.oPosY = o.oPosY -6
   elseif o.oTimer >= 110 and o.oTimer <= 220 then
   o.oPosY = o.oPosY +6
   elseif o.oTimer >= 220 then
	   o.oTimer = 0
	   network_send_object(o, true)
   end
end

Bhv_Custom_0x13000230 = hook_behavior(nil, OBJ_LIST_SURFACE, true, b3rot_init, b3rot_loop, "Bhv_Custom_0x13000230")

------ B3 ROT2 ------

---@param o Object
function b3rot2_init(o)
	obj_set_model_extended(o, E_MODEL_B3ROT2)
	o.collisionData = COL_B3ROT2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true

end

---@param o Object
function b3rot2_loop(o)

	load_object_collision_model()
	o.oFaceAngleYaw = o.oFaceAngleYaw +256
	o.oAngleVelYaw = 256
end

bhvCapSwitchBase = hook_behavior(id_bhvCapSwitchBase, OBJ_LIST_SURFACE, true, b3rot2_init, b3rot2_loop, "bhvCapSwitchBase")

------ B3 ROT3 ------

---@param o Object
function b3rot3_init(o)
	obj_set_model_extended(o, E_MODEL_B3ROT3)
	o.collisionData = COL_B3ROT3
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2048
end

---@param o Object
function b3rot3_loop(o)

	load_object_collision_model()
	o.oFaceAngleRoll = o.oFaceAngleRoll +128
	o.oAngleVelRoll = 128
end

Bhv_Custom_0x130001d8 = hook_behavior(nil, OBJ_LIST_SURFACE, true, b3rot3_init, b3rot3_loop, "Bhv_Custom_0x130001d8")

------ BOWSER CUTSCENE ------

function bhv_custom_bowser_loop(o)
	if o.oAction ~= 5 and
			o.oAction ~= 6 and
				o.oAction ~= 20 then
			o.oAction = 4
		o.oSubAction = 11
	end
end

id_bhvBowser = hook_behavior(id_bhvBowser, OBJ_LIST_GENACTOR, true, nil, bhv_custom_bowser_loop)

------ C10 BOX ------

---@param o Object
function c10box_init(o)
	obj_set_model_extended(o, E_MODEL_C10BOX)
	o.collisionData = COL_C10BOX
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

function c10box_loop()

	load_object_collision_model()
end

bhvDDDPole = hook_behavior(id_bhvDDDPole, OBJ_LIST_SURFACE, true, c10box_init, c10box_loop, "bhvDDDPole")

------ C12 PLAT ------

---@param o Object
function c12plat_init(o)
	obj_set_model_extended(o, E_MODEL_C12PLAT)
	o.collisionData = COL_C12PLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function c12plat_loop(o)

	load_object_collision_model()
	o.oFaceAngleYaw = o.oFaceAngleYaw + 448
	o.oAngleVelYaw = 448
end

Bhv_Custom_0x130053f0 = hook_behavior(nil, OBJ_LIST_SURFACE, true, c12plat_init, c12plat_loop, "Bhv_Custom_0x130053f0")

------ C12 PLAT2 ------

---@param o Object
function c12plat2_init(o)
	obj_set_model_extended(o, E_MODEL_C12PLAT2)
	o.collisionData = COL_C12PLAT2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 1500
	o.oHomeX = o.oPosX
	o.oHomeY = o.oPosY
	o.oHomeZ = o.oPosZ
	o.oBehParams2ndByte = 3
	network_init_object(o, false, { "oTimer", "oPosY", "oFaceAngleYaw", "oAngleVelYaw", "oAction" })
end

---@param o Object
function c12plat2_loop(o)

	load_object_collision_model()
	if o.oAction == 1 then
		if o.oTimer <= 452 then
		o.oPosY = o.oPosY +15
		o.oFaceAngleYaw = o.oFaceAngleYaw + 450
		o.oAngleVelYaw = 450
	   elseif o.oTimer >= 452 and o.oTimer <= 700 then
		o.oFaceAngleYaw = o.oFaceAngleYaw + 450
		o.oPosY = o.oPosY
	   elseif o.oTimer >= 700 then
		   cur_obj_set_pos_to_home()
		   o.oTimer = 0
		   o.oAction = 0
		   network_send_object(o, true)
		end
	end

	if cur_obj_is_any_player_on_platform() == 1
		and o.oAction == 0
			and not is_bubbled(gMarioStates[0]) then
		o.oAction = 1
		network_send_object(o, true)
	end
end

bhvPenguinRaceFinishLine = hook_behavior(id_bhvPenguinRaceFinishLine, OBJ_LIST_SURFACE, true, c12plat2_init, c12plat2_loop, "bhvPenguinRaceFinishLine")

------ WC LIGHT ------

---@param o Object
function wclight_init(o)
	obj_set_model_extended(o, E_MODEL_WCLIGHT)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	network_init_object(o, false, { "oTimer" })
end

---@param o Object
function wclight_loop(o)

		if o.oTimer <= 180 then
			cur_obj_disable_rendering()
	   elseif o.oTimer >= 180 and o.oTimer <= 181 then
		audio_sample_play(audio_sample_load("thunder.ogg"), gMarioStates[0].pos, (is_game_paused() and 0 or 0.5))
	elseif o.oTimer >= 180 and o.oTimer <= 185 then
			cur_obj_enable_rendering()
	   elseif o.oTimer >= 185 then
		   o.oTimer = 0
		   network_send_object(o, true)
		end
	end

bhvKoopaRaceEndpoint = hook_behavior(id_bhvKoopaRaceEndpoint, OBJ_LIST_SURFACE, true, wclight_init, wclight_loop, "bhvKoopaRaceEndpoint")

------ WC PLATP ------

---@param o Object
function wcplatp_init(o)
	o.collisionData = COL_WCPLATP
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function wcplatp_loop(o)

	load_object_collision_model()
	bhv_tumbling_bridge_platform_loop()
	if o.oBehParams2ndByte == 0 then
		obj_set_model_extended(o, E_MODEL_WCPLATP)
	elseif o.oBehParams2ndByte == 1 then
		obj_set_model_extended(o, E_MODEL_WCPLATG)
	end
end

bhvTTCRotatingSolid = hook_behavior(id_bhvTTCRotatingSolid, OBJ_LIST_SURFACE, true, wcplatp_init, wcplatp_loop, "bhvTTCRotatingSolid")

------ VC PLAT ------

---@param o Object
function vcplat_init(o)
	obj_set_model_extended(o, E_MODEL_VCPLAT)
	o.collisionData = COL_VCPLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 1500
end

function vcplat_loop()

	load_object_collision_model()
	bhv_bbh_tilting_trap_platform_loop()
end

bhvSnowmansBottom = hook_behavior(id_bhvSnowmansBottom, OBJ_LIST_SURFACE, true, vcplat_init, vcplat_loop, "bhvSnowmansBottom")

------ VC PLAT2 ------

---@param o Object
function vcplat2_init(o)
	obj_set_model_extended(o, E_MODEL_VCPLAT2)
	o.collisionData = COL_VCPLAT2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2000
end

---@param o Object
function vcplat2_loop(o)

	load_object_collision_model()
	o.oFaceAngleYaw = o.oFaceAngleYaw + 126
	o.oAngleVelYaw = 126
end

Bhv_Custom_0x13003d10 = hook_behavior(nil, OBJ_LIST_SURFACE, true, vcplat2_init, vcplat2_loop, "Bhv_Custom_0x13003d10")

------ VC PLAT3 ------

---@param o Object
function vcplat3_init(o)
	obj_set_model_extended(o, E_MODEL_VCPLAT3)
	o.collisionData = COL_VCPLAT3
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2000
end

---@param o Object
function vcplat3_loop(o)

	load_object_collision_model()
	o.oFaceAngleRoll = o.oFaceAngleRoll + 192
	o.oAngleVelRoll = 192
end

bhvBigSnowmanWhole = hook_behavior(id_bhvBigSnowmanWhole, OBJ_LIST_SURFACE, true, vcplat3_init, vcplat3_loop, "bhvBigSnowmanWhole")

------ OWGATE ------

---@param o Object
function owgate_init(o)
	obj_set_model_extended(o, E_MODEL_OWGATE)
	o.collisionData = COL_OWGATE
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
end

---@param o Object
function owgate_loop(o)

	load_object_collision_model()
	if get_star_count() >= o.oBehParams >> 24 & 0xFF then
		obj_mark_for_deletion(o)
	end
end

bhvChainChompGate = hook_behavior(id_bhvChainChompGate, OBJ_LIST_SURFACE, true, owgate_init, owgate_loop, "bhvChainChompGate")

------ S1BLOCK ------

---@param o Object
function s1block_init(o)
	obj_set_model_extended(o, E_MODEL_S1BLOCK)
	o.collisionData = COL_S1BLOCK
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2000
	o.oHomeX = o.oPosX
	o.oHomeY = o.oPosY
	o.oHomeZ = o.oPosZ
	bhv_ttc_moving_bar_init()
end

function s1block_loop()
	load_object_collision_model()
	bhv_ttc_moving_bar_update()
end

bhvTower = hook_behavior(id_bhvTower, OBJ_LIST_SURFACE, true, s1block_init, s1block_loop, "bhvTower")

------ S1BLOCK2 ------

---@param o Object
function s1block2_init(o)
	obj_set_model_extended(o, E_MODEL_S1BLOCK2)
	o.collisionData = COL_S1BLOCK2
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 2000
end

function s1block2_loop()
	load_object_collision_model()
end

bhvWfBreakableWallRight = hook_behavior(id_bhvWfBreakableWallRight, OBJ_LIST_SURFACE, true, s1block2_init, s1block2_loop, "bhvWfBreakableWallRight")

------ EXCLAMATION ------

---@param o Object
function ex_init(o)
	obj_set_model_extended(o, E_MODEL_EXCLAMATION_POINT)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
end

---@param o Object
function ex_loop(o)
	o.oFaceAngleYaw = o.oFaceAngleYaw + 0x600
end

bhvSLSnowmanWind = hook_behavior(id_bhvSLSnowmanWind, OBJ_LIST_SURFACE, true, ex_init, ex_loop, "bhvSLSnowmanWind")

------ EXCLAMATION ------

local ACT_STAND = 0
local ACT_START = 1
local ACT_SPEED = 2
local ACT_SPEED2 = 3
local ACT_SPEED3 = 4
local ACT_FINISH = 5
local ACT_GOHOME = 6

---@param o Object
function mcplat_init(o)
	obj_set_model_extended(o, E_MODEL_MCPLAT)
	o.collisionData = COL_MCPLAT
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	o.oHomeY = o.oPosY
	network_init_object(o, false, { "oPosY", "oVelY", "oTimer", "oAction" })
	for i = 0, 7 do
		local ball = spawn_object(o, E_MODEL_TRAJECTORY_MARKER_BALL, id_bhvPyramidElevatorTrajectoryMarkerBall)
		ball.oPosY = 4000 + i * 460
	end
end

---@param o Object
function mcplat_loop(o)
	load_object_collision_model()

		if o.oAction == ACT_STAND then
			if cur_obj_is_any_player_on_platform() == 1
					and not is_bubbled(gMarioStates[0]) then
				o.oAction = ACT_START
			network_send_object(o, true)
		end
	end

		if o.oAction == ACT_START then
			o.oPosY = o.oHomeY - sins(o.oTimer * 0x1000) * 10
			if (o.oTimer == 8) then
				o.oAction = ACT_SPEED
		network_send_object(o, true)
				end
			end

		if o.oAction == ACT_SPEED then
			o.oVelY = 10
			o.oPosY = o.oPosY + o.oVelY
			if (o.oPosY > 4875) then
				o.oPosY = 4875
				o.oAction = ACT_SPEED2
		network_send_object(o, true)
			end
		end

	if o.oAction == ACT_SPEED2 then
		if (o.oTimer >= 100) then
			o.oVelY = 10
			o.oPosY = o.oPosY + o.oVelY
			if (o.oPosY > 6075) then
				o.oPosY = 6075
				o.oAction = ACT_SPEED3
		network_send_object(o, true)
			end
		end
	end

	if o.oAction == ACT_SPEED3 then
		if (o.oTimer >= 100) then
			o.oVelY = 10
			o.oPosY = o.oPosY + o.oVelY
			if (o.oPosY > 7339) then
				o.oPosY = 7339
				o.oAction = ACT_FINISH
		network_send_object(o, true)
			end
		end
	end

		if o.oAction == ACT_FINISH then
			o.oPosY = sins(o.oTimer * 0x1000) * 10 + 7339
			if (o.oTimer == 8) then
				o.oAction = ACT_GOHOME
				network_send_object(o, true)
			end
		end

		if o.oAction == ACT_GOHOME then
			o.oVelY = -20
			o.oPosY = o.oPosY + o.oVelY
			if (o.oPosY < 3555) then
				o.oPosY = 3555
				o.oAction = ACT_STAND
		network_send_object(o, true)
			end
		end
	end

bhvPyramidElevator = hook_behavior(id_bhvPyramidElevator, OBJ_LIST_SURFACE, true, mcplat_init, mcplat_loop, "bhvPyramidElevator")

------ C3 FLame ------

local sFish = {
	interactType	  = INTERACT_DAMAGE,
	downOffset		= 100,
	damageOrCoinValue = 4,
	health			= 0,
	numLootCoins	  = 0,
	radius			= 300,
	height			= 400,
	hurtboxRadius	 = 0,
	hurtboxHeight	 = 0,
}

---@param o Object
function fish_init(o)
	obj_set_model_extended(o, E_MODEL_BUBBA)
	obj_set_hitbox(o, sFish)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
	cur_obj_set_home_once()
	network_init_object(o, false, { "oVelY", "oGravity", "oTimer", "oPosY", "oPosX", "oPosZ", "oFaceAnglePitch", "oInteractStatus" })
end

---@param o Object
function fish_loop(o)

	o.oFaceAnglePitch = o.oFaceAnglePitch + 0x600

	if (o.oTimer == 20) then
		cur_obj_play_sound_1(SOUND_OBJ_BUBBA_CHOMP)
	end

	if o.oTimer <= 25 then
		cur_obj_enable_rendering()
		o.oGravity = 10
		o.oVelY = 165
		cur_obj_move_using_vel_and_gravity()
	elseif o.oTimer >= 25 and o.oTimer <= 75 then
		o.oGravity = -10
		cur_obj_move_using_vel_and_gravity()
	elseif o.oTimer >= 75 and o.oTimer <= 130 then
		cur_obj_disable_rendering()
	elseif o.oTimer >= 130 then
		cur_obj_set_pos_to_home()
		o.oTimer = 0
		network_send_object(o, true)
	end
	if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
		o.oInteractStatus = 1
	end
end

bhvBeginningLakitu = hook_behavior(id_bhvBeginningLakitu, OBJ_LIST_GENACTOR, true, fish_init, fish_loop, "bhvBeginningLakitu")